# -*- coding: utf8 -*-
from WikiException import WikiException

class InvalidPermission(WikiException): pass
class NotImplementError(WikiException): pass

def toBool(c):
	if c == '0':
	 	return False
	return True

class PermField:
	def __init__(self, perm):
		if len(perm) != 2:
			raise InvalidPermission
		self.read = toBool(perm[0])
		self.write = toBool(perm[1])

	def toString(self):
		if self.read:
			c = '1' 
		else:
			c = '0'
		if self.write:
			c = c + '1'
		else:
			c = c + '0'
		return c

	def toBoolList(self):
		return [self.read, self.write]

	def __eq__(self, other):
		if isinstance(other, self.__class__):
			return self.toString() == other.toString()
		return self.toString() == other

	
class Permission: # string을 상속하는게 어떤가-_-
	def __init__(self, s):
		L = list(s.strip())
		self.perms = {
			'admin' : PermField('11'),
			'member' : PermField(L[:2]),
			'group' : PermField(L[2:4]),
			'anony' : PermField(L[4:6])
		}
		
	def __getitem__(self, key):
		return self.perms[key]
	def toString(self):
		return '%s%s%s' % (self.perms['member'].toString(), self.perms['group'].toString(), self.perms['anony'].toString())
	__repr__ = strip = toString
	def toBoolList(self):
		L = []
		L.extend(self.perms['member'].toBoolList())
		L.extend(self.perms['group'].toBoolList())
		L.extend(self.perms['anony'].toBoolList())
		return L

	def __eq__(self, other):
		if isinstance(other, self.__class__):
			return self.toString() == other.toString()
		return self.toString() == other
class PermissionChecker:
	def __init__(self):
		raise NotImplementError
	def permCheck(self, user, permType):
		uType = user.uType
		if user.uid in self.getGroup():
			uType = 'group'
		return getattr(self.perms[uType], permType)
