# -*- coding: utf8 -*-
import os
import sha
import time
import cPickle
import Cookie

import Repository


class Session:
	sessionLife = 60*60*24*30 
	def __init__(self, sid=None):
		self.sid = sid
		self.data = {}
		if not self.sid:
			self._loadSid()
		self._setPath() # self.sessionPath
		if self.isLive():
			self.data = cPickle.load(open(self.sessionPath))
		
	def _setPath(self):
		self.sessionPath = os.path.join(Repository.getSessionRepository(), self.sid)

	def __getitem__(self, name):
		return self.data.__getitem__(name)

	def __setitem__(self, name, value):
		self.data[name] = value
		cPickle.dump(self.data, file(self.sessionPath, 'wb'))
	def has_key(self, key):
		return self.data.has_key(key)
	def _loadSid(self):
		cookie = Cookie.SimpleCookie()
		try:
			cookie.load(os.environ['HTTP_COOKIE'])
			self.sid = cookie['IMSID'].value
		except (Cookie.CookieError, KeyError):
			self.sid = sha.new(repr(time.time())).hexdigest()
			self._burnSid()

	def isLive(self):
		if os.path.exists(self.sessionPath) and  \
			time.time() - os.path.getmtime(self.sessionPath) < self.sessionLife:
			return True
		return False
	def remove(self):
		if os.path.exists(self.sessionPath):
			os.remove(self.sessionPath)
		self.data = {}
	def _burnSid(self):
		cookie = Cookie.SimpleCookie()
		cookie['IMSID'] = self.sid
		cookie['IMSID']['expires'] = 60*60*24*30
		print cookie


