# -*- coding: utf8 -*-
import os

import utils
import Repository
import Request

from WikiException import WikiException
class InvalidTagName(WikiException): pass

class Tag:
	def __init__(self, tagName):
		if not tagName.strip():
			raise InvalidTagName
		self.tagName = tagName
		self.tagPath = os.path.join(Repository.getTagRepository(), utils.encode(tagName))

	def getPagePathList(self):
		if os.path.isfile(self.tagPath):
			pagePathList = filter(None, map(lambda obj:obj.strip(), file(self.tagPath, 'rb').readlines()))
		else:
			pagePathList = []
		return pagePathList
		
	def append(self, page):
		categoryPath = page.category.categoryPath
		pageName = page.pageName
		if page.pagePath not in self.getPagePathList():
			file(self.tagPath, 'a').write(page.pagePath+'\n')
	def remove(self, page):
		categoryPath = page.category.categoryPath
		pageName = page.pageName
		pagePathList = self.getPagePathList()
		try:
			pagePathList.remove(page.pagePath)
			if pagePathList:
				contents = '\n'.join(pagePathList) + '\n'
				file(self.tagPath, 'wb').write(contents)
			else:
				os.remove(self.tagPath)
			return True
		except ValueError: # FIXME 뭐지 이건? List에서 값이 없을때인가?
			return False
	def toLink(self):
		request = Request.Request()
		return '<a href="%s?action=pageListInTag&amp;tagName=%s">%s</a>' % (request.actionPath, utils.encode(self.tagName), self.tagName)
