# -*- coding: utf8 -*-
import os
import sets

import Repository
from Tag import *


class TagManager:
	def __init__(self, tags):
		self.tagRepository = Repository.getTagRepository()
		self.tags = tags
		self.tagSet = self.toSet()

	def getTagString(self):
		return ', '.join(self.tagSet)

	def toSet(self):
		return sets.Set(filter(None, map(lambda tag:tag.strip(), self.tags.split(','))))
	def diff(self, newTags):
		newTagSet = TagManager(newTags).toSet()
		addedTags = newTagSet - self.tagSet 
		removedTags = self.tagSet - newTagSet
		return list(addedTags), list(removedTags)

	def update(self, newTags, page):
		categoryPath = page.category.categoryPath
		pageName = page.pageName
		added, removed = self.diff(newTags)
		for tag in added:
			Tag(tag).append(page)
		for tag in removed:
			Tag(tag).remove(page)
		return True
	def toTagList(self):
		L = []
		for tag in self.tagSet:
			L.append(Tag(tag))
		return L
