# -*- coding: utf8 -*-
import os
import sha

import Repository
import User

from WikiException import WikiException
class AlreadyExistUser(WikiException): pass
class NotCorrectPassword(WikiException): pass
class UserDB:
	def __init__(self):
		self.userDbDir = Repository.getUserRepository()

	def addUser(self, uid,  passwd, email, uType='member'):
		userFilePath = os.path.join(self.userDbDir, uid)
		if self.isExistUser(uid):
			raise AlreadyExistUser
		passwd = sha.new(passwd).hexdigest()
		file(userFilePath, 'wb').write('\n'.join([uType, passwd, email]))
		return User.User(uid)
	def getUser(self, uid, passwd):
		user = User.User(uid)
		passwd = sha.new(passwd).hexdigest()
		if user.passwd != passwd:
			raise NotCorrectPassword
		return user
	def isExistUser(self, uid):
		userFilePath = os.path.join(self.userDbDir, uid)
		if os.path.exists(userFilePath):
			return True
		return False
	def getUidList(self):
		if os.path.exists(self.userDbDir):
			return os.walk(self.userDbDir).next()[2]
		return []
