# -*- coding: utf8 -*-

import os
import imLib.Request as Request
import imLib.Category as Category
import imLib.config as config

indexKeys = '0 1 2 3 4 5 6 7 8 9 A B C D E F G H I J K L M N O P Q R S T U V W X Y Z 가 나 다 라 마 바 사 아 자 차 카 타 파 하 Others'.split()

request = Request.Request()

def pageNameCmp(lhs, rhs):
	if lhs.pageName > rhs.pageName:
		return 1
	elif lhs.pageName < rhs.pageName:
		return -1
	return 0

def categorizingByIndexKey(pageList):
	pageList.sort(pageNameCmp)
	D = {}
	curIndex = 0
	for page in pageList:
		try:
			pageName = page.pageName.decode(config.charset).encode('UTF-8')
		except UnicodeError:
			pageName = page.pageName
		if pageName < '0' or pageName[0] == '\xe3':
			if D.has_key('Others'):
				D['Others'].append(page)
			else:
				D['Others'] = [page]
			continue

		i = curIndex
		while pageName.upper() > indexKeys[i]:
			i = i + 1
		curIndex = i > curIndex and i - 1 or curIndex
		if D.has_key(indexKeys[curIndex]):
			D[indexKeys[curIndex]].append(page)
		else:
			D[indexKeys[curIndex]] = [page]
	return D

def run():

	category = Category.getCategoryByCategoryPath(request.categoryPath)
	pageList = category.getPageListFromDescendants()
	D = categorizingByIndexKey(pageList)
	existIndexKeys = []
	for key in indexKeys:
		if D.has_key(key):
			existIndexKeys.append(key)

	L = []
	for key in existIndexKeys:
		L.append('<a href="#%s">%s</a>' % (key, key))	
	L = ['<div><center>%s</center></div>' % ' | '.join(L)]
	for key in existIndexKeys:
		if not D.has_key(key):
			continue
		L.append('<h2><a id="%s" name="%s">%s</a></h2>' % (key, key, key))
		L.append('<ul>')
		for page in D[key]:
			L.append('<li>%s</li>' % page.toLink())

		L.append('</ul>')
	return ''.join(L)
