# -*- coding: utf8 -*-
import re
import config

pat = '([_a-zA-Z0-9]+)(\(.+\)){0,1}'
compiledPat = re.compile(pat)
macroDict = {}

def setMacroPath(path): # for unittest.
	config.macroPackagePath = path

def extractArgs(matchedStr):
	global compiledPat
	macroName, args = compiledPat.match(matchedStr).groups()
	ret = [macroName]
	if args:
		args = map(lambda obj:obj.strip(), args[1:-1].split(','))
	ret.append(args)
	return ret

def loadMacro(macroName):
	macroModulePath = config.macroPackagePath + macroName 
	try:
		package = __import__(macroModulePath, globals(), locals(), True)
	except ImportError: 
		return None
	return package # macro module.

def runMacro(macroName, args):
	global macroDict
	if not macroName in macroDict.keys():
		macroModule = loadMacro(macroName)
		if not macroModule:
			return None
		macroDict[macroName] = macroModule
	macroFunc = macroDict[macroName].run
	if macroFunc.func_code.co_argcount:
		return macroFunc(args)
	return macroFunc()
