#! /usr/bin/python
# -*- coding: utf8 -*-
import cgitb; cgitb.enable()
import os
import cgi
import shutil

from imLib import Repository
from imLib import Category
from imLib import Page
from imLib import UserDB
from imLib import config

teul = '''<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<meta http-equiv="Content-Type" content="text/html;charset=utf-8" />
	<link rel="stylesheet" type="text/css" media="screen" href="%s/css/default.css" />
	<link rel="stylesheet" type="text/css" media="print" href="%s/css/print.css" />
	<title>ImWiki Installation - %s</title>
</head>
<body>
%s
</body>
</html>'''

def html(title, contents):
	print 'Content-type: text/html\n'
	return teul % (config.urlPrefix, config.urlPrefix, title, contents)

def do_printLicense():
	text = file('LICENSE', 'r').read()
	contents = '''<p>이 프로그램은 다음의 라이센스를 따릅니다.</p>
<pre>%s</pre>
<form action="setup.cgi" method="POST">
	<input type="hidden" name="step" value="createRepository" />
	<input type="submit" name="agree" value="Agree" />
</form>
''' % text
	return html('License', contents)


def do_createRepository():
	# 퍼미션검사부터.. seed랑 imwiki폴더
	parentPath = os.path.split(config.repositoryPath)[0] or '.'
	if not os.access(parentPath, os.W_OK):
		msg = '''<p>저장소를 생성할 폴더에 쓰기 권한이 없습니다. 확인하시고 다시 시도하세요.</p>
<form action="setup.cgi" method="POST">
	<input type="hidden" name="step" value="createRepository" />
	<input type="submit" name="try" value="Try again" />
</form>'''
		return html('Create Repository', msg)
	Repository.createRepository()
	print 'Location: setup.cgi?step=copySeedPages'
	print 'Content-type: text/plain\n'
	print 'Location: setup.cgi?step=copySeedPages'

def do_copySeedPages():
	pageRepository = Repository.getPageRepository()
	g = os.walk('seed')
	cur, dirs, files = g.next()
	category = Category.Category()
	while g:
		if cur[5:]:
			category = Category.createCategoryByCategoryPath(cur[5:])
		for fname in files:
			filePath = os.path.join(cur, fname)
			rawText, tags, permission = readPage(filePath)

			Page.createPage(category, fname, rawText, tags, permission)
		try: 
			cur, dirs, files = g.next()
			while 'svn' in cur:
				cur, dirs, files = g.next()
		except StopIteration: 
			break
	print 'Location: setup.cgi?step=regAdminForm'
	print 'Content-type: text/plain\n'
	print 'Location: setup.cgi?step=regAdminForm'
def readPage(filePath):
	fp = file(filePath, 'rb')
	permission = fp.readline().strip()
	tags = fp.readline().strip()
	rawText = fp.read()
	fp.close()
	return rawText, tags, permission

def do_regAdminForm():
	udb = UserDB.UserDB()
	if udb.getUidList():
		return html('Admin Registration', '<p>이미 회원이 있습니다.</p>')
	formTeul = '''<strong>Admin Registration</strong>
<form name="regAdmin" method="POST">
	<input type="hidden" name="step" value="regAdmin" />
	uid <input type="text" name="uid" />
	passwd <input type="password" name="passwd" />
	email <input type="text" name="email" />
	<input type="submit" value="submit" />
</form>'''
	return html('Admin Registration', formTeul)

def do_regAdmin(form):
	uid = form.getvalue('uid', '').strip()
	passwd = form.getvalue('passwd', '').strip()
	email = form.getvalue('email', '').strip()
	if uid and passwd and email:
		udb = UserDB.UserDB()
		udb.addUser(uid, passwd, email, 'admin')
		print 'Location: setup.cgi?step=theEnd'
		print 'Content-type: text/plain\n'
		print 'Location: setup.cgi?step=theEnd'
	return html('Admin Registration', '<p>모든 필드를 채워주세요</p>')	

def do_theEnd():
	return html('End', '<p>모든 설치가 끝났습니다. <a href="imwiki.cgi">시작</a>을 누르면 시작합니다.')

if __name__ == '__main__':
	form = cgi.FieldStorage()
	step = form.getvalue('step', 'printLicense')
	init = form.getvalue('init', '')
	if init:
		Repository.removeRepository()
	action = globals().get('do_'+step)
	if action.func_code.co_argcount > 0:
		print action(form)
	else:		
		print action()
